;	*****************************
;	The data segment for Messages
;	*****************************
;
	ratetblx db	 '38400'         ;the baudrate string
		 db	 022h		 ;CSR content
		 db	 80h		 ;ACR[7] value
	unit_len   equ	$ - ratetblx
		db	'19200'
		db	0cch
		db	080h
		db	'9600 '
		db	0bbh
		db	80h
;
		db	'7200 '
		db	0aah
		db	07fh
;
		db	'4800 '
		db	99h
		db	80h
		db	'2400 '
		db	88h
		db	80h
;
		db	'1800 '
		db	0aah
		db	80h
;
		db	'1200 '
		db	66h
		db	80h
		db	'600  '
		db	55h
		db	80h
		db	'300  '
		db	44h
		db	80h
		db	'200  '
		db	33h
		db	07fh
		db	'150  '
		db	33h
		db	080h
		db	'134.5'
		db	022h
		db	07fh
		db	'110  '
		db	11h
		db	80h
		db	'75   '
		db	0
		db	080h
		db	'50   '
		db	0
		db	07fh
last_tbl	equ	$ -  ratetblx
;
;	************************************************************
;	This Module defines the messages for all the other modules.
;	************************************************************
;
;	********** Messages for Text Atom ************
;
a81x	 db	 'CLEAR'
a81s	equ	$ - a81x	 ;Length of a81
a82x	 db	 'RUN'
a82s	equ	$ - a82x
a83x	 db	 'PRINT'
a83s	equ	$ - a83x
a84x	 db	 'CONTINUE'
a84s	equ	$ - a84x
aa0x	 db	 'PRINT'
aa0s	equ	$ - aa0x
aa1x	 db	 'LOAD '
aa1s	equ	$ - aa1x
ae6x	 db	 'STATEMENT # '
ae6s	equ	$ - ae6x
;	********* End of Text Atom Messages **********
pswinitx db	 'MXFPSW'
verinitx db	 '0.93'
;
msgqx	 db	 'ARE YOU ',02h,04h,04h,00h,0eh,'SURE',0fh,'? (Y/N) : '
msgql	equ	$ - msgqx
msgansx  db	 0dh,0ah,'ARE YOU SURE? (Y/N)',07h
msgansl equ	$ - msgansx
msgnox	 db	 'CANCELLED',0dh,0ah
msgnol	equ	$ - msgnox
msgc4x	 db	 0ah,0dh,'ENTER NEXT MXF COMMAND:',0dh,0ah,'%'
msgc4l	equ	$ - msgc4x
msgc1x	 db	 'ERROR !',07h,0dh,0ah
msgc1l	equ	$ - msgc1x
msgc2x	 db	 'OK',0dh,0ah
msgc2l	equ	$ - msgc2x
msgc3x	 db	 0ch,0dh,'C //////////////////////////',0dh,0ah
msgc3l	equ	$ - msgc3x
msgc7x	 db	 0DH,0AH,'B Set baudrate'
	db	0DH,0AH,'C Set psw'
	db	0DH,0AH,'D Download'
	db	0DH,0AH,'E Analog Loopback'
	db	0DH,0AH,'F Digital Loopback'
	db	0DH,0AH,'H Help'
	db	0DH,0AH,'I Ram Test'
	db	0DH,0AH,'L Lock'
	db	0DH,0AH,'? Status',0DH,0AH
msgc7l	equ	$ - msgc7x
msgclx	 db	 'BAUDRATE LOCKED',0AH,0DH
msgcll	equ	$ - msgclx
msgcunlx db	 'BAUDRATE UNLOCKED',0AH,0DH
msgcunll equ	$ - msgcunlx

msgml0x  db	 '2236 MXF RELEASE 1.00 (MVP) W/TC 01 APR 1990',0DH,0AH
msgml0l equ	$ - msgml0x
msgml01x db	 02h,04h,04h,00h,0eh	 ;flashing attribute
msgml1x  db	 ' ',0fh         ;stop flashing
msgml2x  db	 '1  '           ;terminal #
	 db	 'O'
msgml3x  db	 'FF '           ;terminal status
msgml4x  db	 '19200'         ;current baudrate
msgml41x db	 ' ('            ;current baudrate lock status
msgml42x db	 '19200) '       ;hardware baudrate setting
msgml44x db	 'LOC '
msgml5x  db	 10 dup ( )	 ;terminal type (currently empty)
	 db	 0dh,0ah
msgml1l equ	$-msgml1x	 ;# bytes to print WO/blink
msgml01l equ	$-msgml01x	 ;# bytes to print W/blink
msgmd1x  db	 0dh,'Enter MXF Command:',0ah,0dh,'%'
msgmd1l equ	$-msgmd1x
;
msgmd2x  db	 return,dwnarrow
msgmd2l equ	$ - msgmd2x
msgmd3x  db	 'EXIT MXF COMMAND MODE'
	 db	 return,dwnarrow
msgmd3l equ	$ - msgmd3x
;
msgtyp1x db	 'WANG TERM '
msgtyp2x db	 'Asynch    '
;
msgtc1x  db	 'LOC'
msgtc2x  db	 'REM'
;
msger3x  db	 'PASSWORD '
	 db	 'INCORRECT'
	 db	 return
	 db	 dwnarrow
msger3l equ	$ - msger3x
;
msgcax	 db	 'ANALOG '
msgcal	equ	$ - msgcax
msgcdx	 db	 'DIGITAL '
msgcdl	equ	$ - msgcdx
;
msglpedx db	 'LOOPBACK '
	 db	 'SUCCESS'
	 db	 return
	 db	 dwnarrow
msglpedl equ	$ - msglpedx
;
msglperx db	 'LOOPBACK '
	 db	 'ERROR'
	 db	 return
	 db	 dwnarrow
msglperl equ	$ - msglperx
;
msgm1x	 db	 'NO MEMORY '
	 db	 'ERROR!'
	 db	 return
	 db	 dwnarrow
msgm1l	equ	$ - msgm1x
;
msgm2x	 db	 'MEMORY '
	 db	 'ERROR!'
	 db	 return
	 db	 dwnarrow
msgm2l	equ	$ - msgm2x
;
blinkx	 db	 0fbh,0fch		 ;set cursor blinking
blinks	 equ	 $ - blinkx		 ;# bytes to set cursor blinking
noblinkx db	 0fbh,0f8h		 ;set cursor steady
noblinks equ	$ - noblinkx		 ;# bytes to set cursor blinking
lenp	 equ	$ - ratetblx
lengthl  equ	lenp + 2
;
;	masking of base address for each port
		dw	0
		dw	0
termbase	dw	1600h
		dw	0
		dw	3200h
		dw	0
		dw	4e00h
		dw	0
		dw	6a00h
		dw	0
		dw	8600h
		dw	0
		dw	0a200h
		dw	0
		dw	0be00h
		dw	0
		dw	0da00h
		dw	0
		dw	0f600h
		dw	0
		dw	1200h
		dw	1
		dw	2e00h
		dw	1
		dw	4a00h
		dw	1
		dw	6600h
		dw	1
		dw	8200h
		dw	1
		dw	9e00h
		dw	1
		dw	0ba00h
		dw	1
genbase 	dw	600h
		dw	0
;
