MATHRNDX:
	PUSHREGS			;On entry EDX pt to parameter X
	MOV	AX,WORD PTR [EDX+2]	;CHECK IF X = 0 ?
	OR	AX,WORD PTR [EDX+4]	;
	OR	AX,WORD PTR [EDX+6]	;
	JNZ	mrd_3			;BR, IF <> 0
	MOV	EDI,CPBASE		;GET CURRENT BASE
	LEA	EDI,[EDI].@MTHSEED	;PT TO PARTITION RANDOM# SEED
	MOV	EAX,52ACFFF3H		;PUT THE DEFAULT VALUE IN
	STOSD				;
	MOV	EAX,0170F30EH		;
	STOSD				;
	MOV	EDI,EDX 		;GET PTR OF X
	MOV	EAX,52ACFFF3H		;PUT THE DEFAULT VALUE IN
	STOSD				;
	MOV	EAX,0170F30EH		;
	STOSD				;
	XOR	EDX,EDX 		    ;GET PARTITION MODE
	MOV	DL,BYTE PTR [PART_]
	ADD	EDX,OFFSET PMODE
	AND	BYTE PTR [EDX],0FFH-PMODER  ;TURN OFF RANDOMIZATION
	POPREGS
	RET
MRD_3:
	PUSH	EDX			;SAVE X PTR FOR A BIT
	MOV	ESI,CPBASE		;
	LEA	ESI,[ESI].@MTHSEED	;GET PTR OF PARTITION RANDOM# SEED
	XOR	EDX,EDX 		;
	MOV	EAX,DWORD PTR [ESI+2]	;GET M1, M2
	MOV	EBX,EAX 		;
;@@	MOV	EBX,DWORD PTR SAVESEED+4
	MOV	DX,WORD PTR [ESI+6]	;GET M3
	OR	EAX,EDX 		;LAST RANDOM# = 0 ?
	JZ	mrd_8
	SHL	EDX,16
	MOV	DX,WORD PTR SAVESEED+6	;
MRD_4:					;EBX = M1, M2 CX = M3 OF LAST SYS MANT
	MUL	EBX			;
	XCHG	AH,AL
	MOV	EBX,EAX 		;
	MOV	EAX,DWORD PTR SAVESEED+2
	XOR	EAX,DWORD PTR [ESI+4]
;;	XCHG	DH,DL			;@@
	MUL	EDX			;
	ROL	AX,3			;
	MOV	DX,AX			;
MRD_5:
	CMP	DX,0918H		;IF OVER MAX VALUE
	JA	MRD_6			;
	JB	MRD_53
	CMP	EBX,4E729FFFH
	JBE	MRD_53
MRD_59:
	MOV	EDX,DWORD PTR [ESI+2]	;
;	MOV	EDX,DWORD PTR timed	;
	MOV	EAX,EDX 		;
MRD_6:
	MOV	EBX,DWORD PTR SAVESEED+2
;	MOV	EBX,DWORD PTR timed+2
	MOV	CX,AX
	AND	CX,07H
	INC	CL
	ROL	EAX,CL
	MOV	ECX,EAX
	JMP	mrd_4
MRD_53:
	MOV	AX,0FFF3H
MRD_7:
	MOV	CX,DX			;
	MOV	WORD PTR [ESI+6],CX	;NEW SEED M3
	MOV	DWORD PTR [ESI+2],EBX	;NEW SEED M1,M2
	MOV	WORD PTR [ESI],AX	;
	POP	EDX			;RESTORE X PTR
	MOV	WORD PTR [EDX+6],CX	;NEW SEED M3
	MOV	DWORD PTR [EDX+2],EBX	;NEW SEED M1,M2
	MOV	WORD PTR [EDX],AX	;EXP
	POPREGS
	RET
MRD_8:
	MOV	EAX,DWORD PTR [ESI+4]	;
;	MOV	EAX,dword ptr timed+4
	XOR	EAX,0170F30EH
	MOV	EBX,DWORD PTR SAVESEED+4
;	MOV	EBX,dword ptr timed+4
	XOR	EBX,52AC2B14H
;@@	MOV	DX,word ptr timed+5
	MOV	DX,WORD PTR [ESI+2]
	XOR	DX,3B65H
	JMP	mrd_4

;***********************************************************************
;Following sections are the routine of MATHNRND
;	To calculate next random number and save new seed back.
MATHNRND:

	push	edx
	mov	edx,dword ptr saveseed+2
	xor	ebx,ebx
	mov	bx,word ptr saveseed+6
	mov	eax,ebx
	add	eax,edx
	mov	ecx,edx
	add	edx,edx
	adc	ebx,ebx
	add	edx,edx
	adc	ebx,ebx
	add	edx,ecx
	adc	ebx,eax
	mov	word ptr saveseed+6,bx
	pop	edx
	RET


;MATHINT: Retrun greatest integer which is less then the value.
;
;The routine check numeric value first, to decide whether the value is an
;INTEGER already; if it is then the result is the value itself.  If the value
;is not a INTEGER then take following step to do the function:
;	(1)Change representation into positive if necessary
;	(2)Divide mantissa portion by 10, until exponent = 0
;	(3)Check original value is positive of negative, remainder = 0 or not.
;	   If remainder <> 0 then result - 1 if value is negative, result + 1
;	   if value if positive.
;
;
MATHINT:
	EVEN
	MOV	AX,WORD PTR [EDX]	;GET THE EXP OF X
	OR	AX,AX		;>= 0 ?
	JNS	MINT_1		;NO NEED FOR INT FUNCTION
	MOV	EDI,EDX 	;EDI PT TO RETURN BUFFER
	MOV	EBX,EDX 	;EBX PT TO SOURCE VALUE
	MOV	AX,1		;FLAG ENTRY FROM MATHINT
	JMP	MINT		;PERFORM INT FUNTION
MINT_1:
	RET

MINT:
	PUSHREGS		;
MINT_2:
	PUSH	EDI		;EDI PT TO THE RETURN BUFFER
	PUSH	AX		;
	MOV	ESI,EBX 	;EBX PT TO OPERAND X
	MOV	AX,WORD PTR [ESI]
	MOV	EXP_S,AX	;SAVE EXP
	MOV	EDX,0		;
	MOV	DX,WORD PTR [ESI+6]
	MOV	EDI,DWORD PTR [ESI+2]
	PUSH	DX		;SAVE M3
	OR	DX,DX		;NEGATIVE?
	JNS	MINT_3		;NO,

	NOT	DX		;2'S COMPLEMENT
	NEG	EDI		;
	JNZ	MINT_3		;
	INC	DX		;

MINT_3:
	MOV	ECX,EDI 	;ECX = M1, M2
	MOV	ESI,EDX 	; SI = M3
MINT_39:
	MOV	EBP,-1		;INIT EXP COUNT
	MOV	BP,EXP_S	;GET EXP
	CMP	EBP,-9		;ARE WE OVER DWORD INTEGER BOUND?
	JL	MINT_41 	;BR, IF YES
	NEG	EBP		;
	SHL	EBP,3		;
	ADD	EBP,OFFSET CON_2+2
	MOV	EDI,DWORD PTR [EBP]
	MOV	EXP_S,0 	;CLEAR EXP COUNT
MINT_5:
	XOR	EDX,EDX 	;INIT DIVISION BUFFERS
	MOV	AX,SI		;
	CWDE			;
	DIV	EDI		;
	MOV	ESI,EAX 	;SAVE NEW M3
	MOV	EAX,ECX 	;
	DIV	EDI		;
	MOV	ECX,EAX 	;SAVE NEW M1, M2

	CMP	EXP_S,0 	;HAVE WE DONE?
	JNE	MINT_39 	;BR, IF NOT

	POP	AX		;RESTORE ORIGINAL M3
	OR	AX,AX		;CHK SIGN
	JNS	MINT_8		;BR, IF POSITIVE
	NOT	SI		;2'S COMPLEMENT
	NEG	ECX		;
	JNZ	MINT_6		;
	INC	SI		;
;****************************************************************************
;Following sections is used to handle special consideration for routine ROUND
;If restored AX = 0 then means called from ROUND routine, otherwise skip this
;section.
;
MINT_6:
	POP	AX		;RESTORE OPERATION FLAG
	OR	AX,AX		;CHK SIGN
	JS	MINT_9		;BR, IF NEGATIVE
	JNZ	MINT_7		;BR, IF NOT ZERO
	SHL	EDX,1		;
	CMP	EDX,EDI 	;
	JB	MINT_9		;

MINT_7:
	OR	EDX,EDX 	;REMAINDER = 0 ?
	JZ	MINT_9		;BR, IF 0

	SUB	ECX,1		;RESULT = RESULT - 1
	SBB	SI,0		;
	JMP	MINT_9		;

MINT_8:
	POP	AX		;RESTORE OPERATION FLAG
	OR	AX,AX		;
	JNZ	MINT_9		;
	SHL	EDX,1		;
	CMP	EDX,EDI 	;
	JB	MINT_9		;
	INC	ECX		;
	JNZ	MINT_9		;
	INC	SI		;

;******************************
;Store the result value back ..
;
MINT_9:
	POP	EDI		;GET THE PTR OF RETURN BUFFER
	MOV	WORD PTR [EDI+6],SI
	MOV	DWORD PTR [EDI+2],ECX
	MOV	WORD PTR [EDI],0
	CMP	ESC_FLAG,-1	;
	JE	MINT_A
	POPREGS
MINT_A:
        RET

MINT_41:
	MOV	EDX,0		;
	MOV	EAX,EBP 	;GET EXP
	MOV	EDI,9		;
	DIV	EDI		;

	OR	EDX,EDX 	;REMAINDER = 0 ?
	JZ	MINT_42 	;BR, IF YES

	ADD	EXP_S,DX	;UPDATE EXP
	SHL	EDX,3		;
	ADD	EDX,OFFSET CON_2+2
	MOV	EDI,DWORD PTR [EDX]
	JMP	MINT_5		;
MINT_42:
	ADD	EXP_S,9 	;
	MOV	EDI,1000000000	;
	JMP	MINT_5		;

;MATHFIX: Retrun integer portion of value.
;
;The routine check numeric value first, to decide whether the value is an
;INTEGER already; if it is then the result is the value itself.  If the value
;is not a INTEGER then take following step to do the function:
;	(1)Make use of same processing routine of MATHINT with different flag.
;	   The flag disable carry in while negative value is processed for
;	   MATHINT.
MATHFIX:
	EVEN
	MOV	AX,WORD PTR [EDX]	;GET THE EXP OF X
	OR	AX,AX		;>= 0 ?
	JNS	MFIX_1		;NO NEED FOR FIX FUNCTION
	MOV	EDI,EDX 	;EDI PT TO RETURN BUFFER
	MOV	EBX,EDX 	;EBX PT TO SOURCE VALUE
	MOV	AX,-1		;FLAG ENTRY FROM MATHFIX
	JMP	MINT		;PERFORM INT FUNTION
MFIX_1:
	RET

;MATHABS: Return the absolute value
;
MATHABS:
	EVEN
	mov	r0,0
	MOV	AX,WORD PTR [EDX+6]	;GET THE M3 OF X
	OR	AX,AX		;>= 0 ?
	JNS	MABS_2		;NO NEED TO COMPLEMENT
	PUSHREGS

	MOV	ECX,DWORD PTR [EDX+2]
	NOT	ECX
	ADD	ECX,1
	MOV	DWORD PTR [EDX+2],ECX
	MOV	AX,WORD PTR [EDX+6]
	NOT	AX
	ADC	AX,0
	MOV	WORD PTR [EDX+6],AX
	JNO	MABS_1
	MOV	EDI,EDX
	CALL	MANADJ		;NORMALIZATION ROUTINE

MABS_1:
	POPREGS
MABS_2:
	RET

;*******************************************************
;MATHMOD: MOD(X/Y)  Finds the remainder of X/Y.
;	Upon entry: EDX - ptr of Y, EDX+8 - ptr of X
;
MATHMOD:

	EVEN
	ADD	EDX,8			;WHEN RETURN EDX SHOULD PT TO X
	PUSHREGS
	PUSH	EDX			;SAVE PTR OF X
	MOV	ESI,EDX 		;ESI - PTR OF X
	SUB	EDX,8			;PTR TO Y
	MOV	EBX,EDX 		;EBX - PTR OF Y
	MOV	EAX,DWORD PTR [EBX+2]	;GET M1,M2_Y
	OR	EAX,EAX 		; = 0 ?
	JNZ	MMOD_05 		;BR, IF NOT
	OR	AX,WORD PTR [EBX+6]	; = 0 ?
	JZ	MMOD_2			;BR IF = 0

MMOD_05:
	MOV	AX,WORD PTR [EBX]	;GET EXP_Y
	CMP	AX,WORD PTR [ESI]	;IF EXP_X = EXP_Y ?
	JE	MMOD_3			;BR, IF YES

	MOV	PTR_A,ESI		;SAVE X PTR
	MOV	PTR_B,EBX		;SAVE Y PTR

	MOV	EDX,EBX 		;PREPARE PARAMTERS FOR DIVIDE
	MOV	EBX,ESI 		;
	MOV	EDI,OFFSET OPR_S	;EDI PT TO BUFFER ADDRESS
	CALL	MDIV			;CALL MATHDIV
	MOV	EDX,OFFSET OPR_S	;EDX PT TO RESULT OF (X/Y)
	MOV	AX,WORD PTR [EDX]	;GET EXP
	OR	AX,AX			;BR, IF VALUE IS AN INTEGER
	JNS	MMOD_1			;
	MOV	EDI,EDX 		;PREPARE FOR MATHINT ROUTINE
	MOV	EBX,EDX 		;
	MOV	AX,0001 		;
	CALL	MINT			;CALL MATHINT
MMOD_1:
	MOV	EBX,OFFSET OPR_S	;
	MOV	EDX,PTR_B		;GET PTR TO Y
	MOV	EDI,EBX 		;EBX PT TO RESULT INT (X/Y)
	CALL	MMUL			;CALL MATHMUL
	MOV	ESI,OFFSET OPR_S	;ESI PT TO RESULT OF Y*INT(X/Y)
	MOV	EDI,OFFSET TEMP_Y
	MOVSD				;MOVE TO RESULT INTO OPERAND Y
	MOVSD				;
	MOV	EBX,OFFSET TEMP_Y	;EBX PT TO RESULT OF Y*INT(X/Y)
	MOV	ESI,PTR_A		;GET PTR TO X
	POP	EDI			;RESTORE RETURN BUFFER ADDR
	PUSH	EDI			;SAVE

	MOV	EDI,OFFSET MATHAREA	;WORKING AREA PTR FOR MATHSUB
	PUSH	EDI			;

	JMP	msub_2			;JMP TO MATHSUB
;

MMOD_2:
	POP	EAX			;FOR STACK BALENCE
	POPREGS 			;
	RET				;IF Y=0 THEN MOD(X,0) = X

;----------------------------------------
;CASE : EXP_X = EXP_Y
;	ESI PT TO X, EBX PT TO Y
;
MMOD_3:
	MOV	EXP_S,AX		;SAVE EXP FOR A WHILE
	MOV	DI,WORD PTR [ESI+6]	;GET M3_X
	MOV	EBP,DWORD PTR [ESI+2]	;    M1,M2_X
	MOV	AX,WORD PTR [EBX+6]	;    M3_Y
	MOV	EDX,DWORD PTR [EBX+2]	;    M1,M2_Y
	MOV	M3_X,DI 		;SAVE OLD M3_X
	MOV	M3_SAV,AX		;     OLD M3_Y
	OR	DI,DI			;X < 0 ?
	JNS	MMOD_4			;BR, IF NOT
	NOT	DI			;
	NEG	EBP			;
	JNZ	MMOD_4			;
	INC	DI			;
MMOD_4:
	OR	AX,AX			;Y < 0 ?
	JNS	MMOD_5			;BR, IF NOT
	NOT	AX			;
	NEG	EDX			;
	JNZ	MMOD_5			;
	INC	AX
MMOD_5:
	MOV	SI,AX			;SAVE Y IN SI_EBX
	MOV	EBX,EDX 		;

	OR	AX,AX			;M3_X = 0
	JNZ	MMOD_6			;BR, IF <> 0

	MOV	AX,DI			;GET M3_X
	CWDE				;
	XOR	EDX,EDX 		;PREPARE FOR DIVIDE
	DIV	EBX			;
	MOV	EAX,EBP 		;GET M1,M2_X
	DIV	EBX			;
	XOR	AX,AX			;
MMOD_9:
	OR	EDX,EDX 		;IF REMAINDER = 0 ?
	JZ	MMOD_D			;BR, IF = 0
MMOD_A:
	TEST	M3_X,8000H		;IF OLD X < 0 ?
	JZ	MMOD_C			;BR, IF NOT
	TEST	M3_SAV,8000H		;IF OLD Y < 0 ?
	JNZ	MMOD_B			;BR, IF YES
	SUB	EDX,EBX 		;
	SBB	AX,SI			;
MMOD_B:
	NOT	AX			;
	NEG	EDX			;
	JNZ	MMOD_D			;
	INC	AX			;
MMOD_D:
	POP	EDI			;RESTORE RESULT PTR
	MOV	WORD PTR [EDI+6],AX	;
	MOV	DWORD PTR [EDI+2],EDX	;
	MOV	AX,EXP_S		;
	MOV	WORD PTR [EDI],AX	;
	POPREGS
	RET
MMOD_C:
	TEST	M3_SAV,8000H		;
	JZ	MMOD_D			;
	SUB	EDX,EBX 		;
	SBB	AX,SI			;
	JMP	MMOD_D			;
MMOD_6:
	XOR	EAX,EAX 		;INIT TEMP RESULT
	XOR	EDX,EDX 		;
	MOV	ECX,48			;LOOP COUNT
MMOD_7:
	SHL	EBP,1			;
	RCL	DI,1			;
	RCL	EDX,1			;
	RCL	AX,1			;
	SUB	EDX,EBX 		;
	SBB	AX,SI			;
	JNB	MMOD_8			;
	ADD	EDX,EBX 		;
	ADC	AX,SI			;
MMOD_8:
	LOOP	MMOD_7			;
	OR	AX,AX			;
	JNZ	MMOD_A			;
	OR	EDX,EDX 		;
	JNZ	MMOD_A			;
	JMP	MMOD_D			;

;***********************************************************************
;Following sections are the routine of MATHRD
;
;	  IF EXP_N <> 0 ...............
MRND_2:
	MOV	PTR_B,EBX		;SAVE PTR OF N
	JNS	MRND_3			;BR, IF EXP_N > 0

	PUSH	EDI			;
	MOV	EDI,OFFSET TEMP_Y	;FIND A WORK AREA FOR INT(N)
	MOV	AX,1			;FLAG FOR MATHINT
	CALL	mint			;CALL MATHINT
	MOV	EBX,OFFSET TEMP_Y	;GET INT(N) RESULT OUT
	POP	EDI			;
	MOV	AX,[EBX+2]		;GET M1_N'
	MOV	DX,[EBX+4]		;    M2
	OR	DX,[EBX+6]		;EXIT, IF M2,M3 = 0
	JNZ	MRND_6			;BR, IF <> 0
	MOV	EBX,PTR_B		;RESTORE N PTR
        RET

;	  IF EXP_N > 0 .............	 AX HAS EXP_N
MRND_3:
	CMP	DWORD PTR [EBX+4],0	;CHK IF M2,M3_N <> 0
	JNE	MRND_7			;BR,

	MOV	DX,[EBX+2]		;GET M1_N (SINCE M2,M3 = 0)
	OR	DX,DX			;BR, IF M1 = 0
	JZ	MRND_5			;

MRND_4:
	CMP	DX,6554 		;MAX. VALUE IN A WORD BEFORE (* 10)
	JA	MRND_6			;BR, IF ABOVE MAX VALUE
	MOV	BX,DX			;M1_N * 10
	SHL	DX,2			;
	ADD	DX,BX			;
	SHL	DX,1			;
	DEC	AX			;EXP_N - 1
	JNZ	MRND_4			;BR, IF EXP_N <> 0
MRND_5:
	MOV	AX,DX			;AX = FINAL M1_N' OR 0
	MOV	EBX,PTR_B		;RESTORE PTR OF N
        RET

MRND_6:
	MOV	EBX,PTR_B		;RESTORE PTR OF N
MRND_7:
	MOV	AX,-1			;FLAG RESULT = X
	RET

MRND_80:
	TEST	EAX,0FFFF0000H
	JNZ	MRND_B
	OR	CX,CX
	JNZ	MRND_B
	JMP	MRND_81

MATHRD:
	;ON ENTRY EDX PT TO Y, EDX+8 PT TO X
	;
MRND_0:
	PUSHREGS
	MOV	ESI,EDX 		;ESI - PTR OF N
	ADD	EDX,8			;EDX - PTR OF X
	PUSH	EDX			;SAVE PTR OF X
	MOV	EDI,OFFSET MATHAREA	;
	PUSH	EDI			;EDI PT TO WORK AREA
	MOV	EBX,EDI 		;

	MOV	DX,WORD PTR [ESI]	;DX = EXP_X
	MOVSW				;SAVE EXP_X
	MOV	EAX,DWORD PTR [ESI]	;EAX = M1,2_X
	MOV	CX,WORD PTR [ESI+4]	;CX = M3_X
	PUSH	CX			;SAVE M3_X
	OR	CX,CX			;IF NEG?
	JNS	MRND_8			;BR, IF POS
	NOT	CX
	NEG	EAX
	JNZ	MRND_8
	INC	CX
MRND_8:
	MOV	DWORD PTR [EDI],EAX
	MOV	WORD PTR [EDI+4],CX
	OR	DX,DX			;CHK EXP_X
	JZ	MRND_80 		;BR, IF ZERO
	CALL	MRND_2			;
	CMP	AX,-1			;
	JE	MRND_B

MRND_81:
	MOV	DX,AX			;DX = N' (N TRANCATES TO AN INTEGER)
	POP	AX			;RESTORE M3_N
	POP	EDI			;RESTORE WORK AREA PTR
	OR	AX,AX			;BR, IF N >= 0
	JNS	MRND_9			;
	NEG	DX			;COMPLEMENT N'

MRND_9:
	POP	ESI			;GET PTR OF X
	PUSH	ESI			;
	MOV	EBX,EDI 		;
	LODSW				;GET EXP_X
	ADD	AX,DX			;ADD N' TO EXP_X
	STOSW				;SAVE BACK
	MOVSW				;MOVE MANTISSA
	MOVSW				;
	MOVSW				;
	MOV	EDI,EBX 		;
	JGE	MRND_A			;BR, IF EXP_X' >= 0  (ALREADY AN INTEGER)

	PUSH	DX			;SAVE N'
	MOV	AX,0000 		;FLAG CALLING FROM ROUND ROUTINE
	CALL	mint			;CALL MATHINT
	POP	DX			;RESTORE N'
MRND_A:
	SUB	[EDI],DX		;UPDATE EXP_X'
	MOV	ESI,EDI 		;
	POP	EDI			;RESTORE X PTR
	MOVSD
	MOVSD
	POPREGS
	ADD	EDX,8			;PT TO X WHEN RETURN
	RET
MRND_B:
	POP	AX			;
	POP	EAX			;
	POP	EAX			;STACK BALANCE
	POPREGS
	ADD	EDX,8
	RET
;
;***********************************************************************
;Following sections are the routine of MATHRND0
;	To initialize random number seed to .1584625767084
;
MATHRND0:
	PUSH	EDI			;
	PUSHF				;
	MOV	EDI,OFFSET SAVESEED	;PT TO SYSTEM RANDOM# SEED
	MOV	EAX,52ACFFF3H		;PUT THE DEFAULT VALUE IN
	STOSD				;
	MOV	EAX,0170F30EH		;
	STOSD				;
	POPF				;
	POP	EDI			;
	RET


;***************************************************************************
PCMP:   ;This routine to compare two value pt by ESI (A) and EDI (B),
        ;when return AL has glag to indicates compare result
	;MODIFIED FOR SPEED UP BY USING REGS AS MUCH AS POSSIBLE 3/22/89
	;EBX-EAX FOR X VALUE, EBP-ECX FRO Y VALUE...

	MOV	EBX,[ESI+4]
	MOV	EAX,[ESI]		;EXP_X IN AX
	MOV	EBP,[EDI+4]		;
	MOV	ECX,[EDI]		;EXP_Y IN CX
	CMP	AX,CX			;CMP EXPONENTS
	JNE	PCMP1			;NEEDS ALIGNMENT

	AND	EAX,0FFFF0000H		;MASK OFF EXP_X
	AND	ECX,0FFFF0000H		;MASK OFF EXP_Y
	SUB	EAX,ECX 		;
	SBB	EBX,EBP
	JL	PCMPL
	JG	PCMPG
	OR	EAX,EBX 		;IS X = Y ?
	JZ	PCMPE			;BR, YES
	JNZ	PCMPG

PCMP1:
	XOR	EBX,EBP 		;CHK SIGN OF THESE TWO VALUE
	JNS	PCMP2			;BOTH HAVE SAME SIGN
	OR	EBP,EBP 		;
	JNS	PCMPL			;X IS NEGATIVE VALUE
	JMP	PCMPG			;Y IS NEGATIVE VALUE
PCMP2:
	MOV	EBX,EDI 		;
	CALL	MALG			;ALIGNMENT
	MOV	EDI,EBX 		;
	JMP	PCMP			;

PCMPL:  MOV     AL,1                    ;A < B
        RET
PCMPG:  MOV     AL,4                    ;A > B
        RET
PCMPE:  MOV     AL,2                    ;A = B
        RET


;MATHSGN: Return the value 1 if the expression is positive, -1 if negative
;	  and 0 if zero.
MATHSGN:
	EVEN
	MOV	WORD PTR [EDX],0	;PUT EXP = 0
	MOV	AX,WORD PTR [EDX+6]	;GET THE M3 OF X
	OR	AX,AX			;NEGATIVE ?
	JS	MSGN_2			;PUT VALUE -1
	JNZ	MSGN_1			;PUT VALUE 1
	OR	AX,WORD PTR [EDX+4]	;CHK M2
	JNZ	MSGN_1			;
	OR	AX,WORD PTR [EDX+2]	;CHK M1
	JNZ	MSGN_1			;
	MOV	DWORD PTR [EDX+4],0	;PUT VALUE 0
	MOV	WORD PTR [EDX+2],0	;
	RET
MSGN_1:
	MOV	DWORD PTR [EDX+4],0	;
	MOV	WORD PTR [EDX+2],1	;
	RET
MSGN_2:
	MOV	DWORD PTR [EDX+4],-1	;
	MOV	WORD PTR [EDX+2],-1	;
	RET
