ADDALIGN PROC
even
;ON ENTRY -- EBX PT TO VALUE X,  ESI PT TO VALUE Y
;
;REGISTER USAGE
;
;	AX - EXP_X	    DX - EXP_Y
;      EDI - M12_X	   EBX - M12_Y
;	SI -  M3_X	    BP -  M3_Y
;

MALG:
	MOV	EAX,DWORD PTR [EBX+2]	;
	OR	EAX,EAX 		;
	JNZ	MALG_0			;
	OR	AX,WORD PTR [EBX+6]	;
	JNZ	MALG_0			;
	MOV	AX,WORD PTR [ESI]	;
	MOV	WORD PTR [EBX],AX	;
	RET
MALG_0:
	MOV	EAX,DWORD PTR [ESI+2]	;
	OR	EAX,EAX 		;
	JNZ	MALG_4			;
	OR	AX,WORD PTR [ESI+6]	;
	JNZ	MALG_4			;
	MOV	AX,WORD PTR [EBX]	;
	MOV	WORD PTR [ESI],AX	;
	RET
MALG_4:

	PUSH	EAX			;SAVE REGS
	PUSH	ECX
	PUSH	EDX
	PUSH	EDI
	PUSH	EBP


	MOV	PTR_FLP,0		;INIT FLAG
	XOR	EAX,EAX 		;
	MOV	EDX,0			;
	MOV	ECX,0			;
	MOV	EBP,0			;
	MOV	AX,[EBX]		;EXP_X
	MOV	EDI,[EBX+2]		;M12_X
	MOV	CX,[EBX+6]		;
	MOV	DX,[ESI]		;EXP_Y
	MOV	EBX,[ESI+2]		;M12_Y
	MOV	BP,[ESI+6]		;M3_Y
	XOR	ESI,ESI
	MOV	SI,CX			;M3_X

MALG_5:
	MOV	ECX,EAX 		;
	SUB	CX,DX			;ECX HAS EXPONENT DIFFERENCE
	JNS	MALG_2			;

	NEG	CX			;MAKE POSITIVE DIFFERENCE
	MOV	PTR_FLP,-1		;FLAG WE HAD CHANGED

	XCHG	EAX,EDX 		;SWAP TWO VALUES
	XCHG	EDI,EBX 		;
	XCHG	ESI,EBP 		;
MALG_2:

	MOV	WORD PTR [OPR_S],DX	;SAVE VALUE Y FOR A BIT
	MOV	DWORD PTR [OPR_S+2],EBX ;
	MOV	WORD PTR [OPR_S+6],BP	;

	MOV	M3_SAV,0		;INIT FLAG
	OR	SI,SI			;CHK SIGN
	JNS	MALG_3			;BR, IF POS
	MOV	M3_SAV,-1
	NOT	SI			;
	NEG	EDI			;
	JNZ	MALG_3			;
	INC	SI			;
MALG_3:
	CMP	SI,0CCCH		;OVER THE MAX VALUE?(as big as possible)
;	CMP	SI,0918H		;OVER THE MAX VALUE?(as big as possible)
	JAE	MALG_6			;BR, IF YES

	MOV	BP,SI			;VALUE X * 10
	MOV	EBX,EDI 		;
	SHL	EDI,1			;
	RCL	SI, 1			;
	SHL	EDI,1			;
	RCL	SI, 1			;
	ADD	EDI,EBX 		;
	ADC	SI,BP			;
	SHL	EDI,1			;
	RCL	SI, 1			;
	LOOP	MALG_3			;

	MOV	DX,WORD PTR [OPR_S]	;RESTORE Y VALUE
	MOV	EBX,DWORD PTR [OPR_S+2] ;
	MOV	BP,WORD PTR [OPR_S+6]	;

					;AT THIS POINT,
	MOV	AX,DX			;EXP_X SHOULD EQUAL EXP_Y
	CMP	M3_SAV,-1		;HAVE WE NEG THE VALUE?
	JNE	MALG_K			;BR, IF NO
	MOV	M3_SAV,0		;RESET
	NOT	SI			;
	NEG	EDI			;
	JNZ	MALG_K			;
	INC	SI			;
	JMP	MALG_K			;TO THE RETURN PT

MALG_6:

	MOV	DX,WORD PTR [OPR_S]	;RESTORE Y VALUE
	MOV	EBX,DWORD PTR [OPR_S+2] ;
	MOV	BP,WORD PTR [OPR_S+6]	;
	MOV	AX,DX			;AT THIS POINT NEW EXP_X SHOULD BE
	ADD	AX,CX			;EXP_Y + N ( NO. OF * 10)
	CMP	M3_SAV,-1		;HAVE WE NEG BEFORE?
	JNE	MALG_7			;BR, IF NO
	MOV	M3_SAV,0
	NOT	SI			;
	NEG	EDI			;
	JNZ	MALG_7			;
	INC	SI			;
MALG_7:
	MOV	WORD PTR [OPR_S],AX	;SAVE THE ALIGNED X VALUE
	MOV	DWORD PTR [OPR_S+2],EDI ;
	MOV	WORD PTR [OPR_S+6],SI	;
	CMP	CX,14			;CHK IF THE DIFFERENCE IS TOO BIG
	JAE	MALG_1			;BR, THAT CAN'T BE HANDLE HERE

	ADD	DX,CX			;CAL THE FINAL EXP_Y
	MOV	WORD PTR [OPR_L],DX	;

	MOV	M3_SAV,0		;INIT FLAG
	OR	BP,BP			;IF THE VALUE Y BE NEG?
	JNS	MALG_9			;BR, IF POS
	MOV	M3_SAV,-1		;
	NOT	BP
	NEG	EBX
	JNZ	MALG_9
	INC	BP
MALG_9:
	AND	ECX,0FFFFH
;	xor	edx,edx
	PUSH	ECX			;SAVE THE DIFFERENCE FOR A BIT
	CMP	ECX,7			;7 IS THE NO THAT CAN HANDLE IN 32 BIT
	JLE	MALG_A			;
	SUB	ECX,7			;
MALG_A:
	XOR	EDX,EDX 		;
	AND	EBP,0FFFFH
	SHL	ECX,3			;
	ADD	ECX,OFFSET CON_2	;CAL THE ADDRESS OF DIVISOR
	MOV	ECX,[ECX+2]		;
	MOV	EAX,EBP 		;DIVIDE Y BY (10 * N)
	DIV	ECX			;
	MOV	EBP,EAX 		;
	MOV	EAX,EBX 		;
	DIV	ECX			;
	MOV	EBX,EAX 		;EBP,EBX HAS THE NEW Y VALUE
	MOV	EAX,ECX 		;TO KEEP THE DIVISOR
MALG_B:
	POP	ECX			;RESTORE THE OLD DIFFERENCE OF EXP
	CMP	ECX,7			;
	JBE	MALG_C

	MOV	ECX,7			;
	PUSH	ECX			;
	JMP	MALG_A			;DO IT AGAIN
MALG_C:
	SHR	EDX,1			;
	CMP	EDX,EAX 		;
	JB	MALG_F			;
	INC	EBX			;
	JNZ	MALG_F			;
	INC	EBP
MALG_F:
	CMP	M3_SAV,-1		;HAVE WE NEG THE VALUE ?
	JNE	MALG_D			;BR, IF NO
	MOV	M3_SAV,0
	NOT	BP
	NEG	EBX
	JNZ	MALG_D
	INC	BP
MALG_D:
	MOV	DX,WORD PTR [OPR_L]	;GET THE EXP_Y

	MOV	AX,WORD PTR [OPR_S]	;GET THE ALIGNED X VALUE
	MOV	EDI,DWORD PTR [OPR_S+2] ;
	MOV	SI,WORD PTR [OPR_S+6]	;
MALG_K:
	CMP	PTR_FLP,-1		;HAVE WE SWAP BEFORE?
	JNE	MALG_E			;BR, IF NO
	MOV	PTR_FLP,0		;RESET
	XCHG	EAX,EDX
	XCHG	EDI,EBX
	XCHG	ESI,EBP

MALG_E:
	MOV	ECX,ESI

	MOV	ESI,OFFSET OPR_S	;
	MOV	[ESI],DX		;SAVE THE NEW Y VALUE
	MOV	[ESI+2],EBX		;
	MOV	[ESI+6],BP		;

	MOV	EBX,OFFSET OPR_L	;
	MOV	[EBX],AX		;SAVE THE NEW X VALUE
	MOV	[EBX+2],EDI		;
	MOV	[EBX+6],CX		;
MALG_L:
	POP	EBP
	POP	EDI
	POP	EDX
	POP	ECX
	POP	EAX
	RET

MALG_1:
	ADD	DX,CX			;UPDATE EXP_Y
	MOV	EBX,0			;M123_Y = 0
	MOV	EBP,0			;
	JMP	MALG_K			;
ADDALIGN    ENDP
